<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.1) on Sat Oct 05 11:12:57 CEST 2019 -->
<title>BinaryClassificationEvaluator (dblp.datatools 2019.08.0.0 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-10-05">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="BinaryClassificationEvaluator (dblp.datatools 2019.08.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">bous.philipp.dblp.datatools.evaluation</a></div>
<h2 title="Class BinaryClassificationEvaluator" class="title">Class BinaryClassificationEvaluator</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>bous.philipp.dblp.datatools.evaluation.BinaryClassificationEvaluator</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">BinaryClassificationEvaluator</span>
extends java.lang.Object</pre>
<div class="block">Used in a scenario where only two classes exist. See the evaluate-methods
 documentation for more information. Can be used for more advanced evaluation-purposes
 in a cross-validation-scenario by holding a list of evaluation sets.
 After evaluating a set of predictions, it can be used to provide detailed performance
 reports which is the main use-case for this class.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">BinaryClassificationEvaluator</a></span>()</code></th>
<td class="colLast">
<div class="block">This standard-constructor will set the classification-threshold to a default of 0.5 and
 will create and set a first <a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation"><code>BinaryEvaluationSet</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(double)">BinaryClassificationEvaluator</a></span>&#8203;(double&nbsp;classificationThreshold)</code></th>
<td class="colLast">
<div class="block">Creates a BinaryClassificationEvaluator taking a classification-threshold to be
 used when labeling.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addWeightedGainConfig(double,double,double,double)">addWeightedGainConfig</a></span>&#8203;(double&nbsp;tprWeight,
                     double&nbsp;tnrWeight,
                     double&nbsp;probPos,
                     double&nbsp;probNeg)</code></th>
<td class="colLast">
<div class="block">Adds a new WeightedGainWeightingInfo to this instance.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#evaluate(double,double)">evaluate</a></span>&#8203;(double&nbsp;actualClass,
        double&nbsp;score)</code></th>
<td class="colLast">
<div class="block">Evaluates a given score and actual class; that means that the score is compared with the classification threshold of the current EvaluationSet
 and according to the given actual class TN/TP/FN/FP values are incremented as necessary.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation">BinaryEvaluationSet</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getCurrentEvaluationSet()">getCurrentEvaluationSet</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the current evaluation set.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>java.util.List&lt;<a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation">BinaryEvaluationSet</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getEvaluationSets()">getEvaluationSets</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns a list of this instances evaluation-sets.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#incrementFalseNegatives()">incrementFalseNegatives</a></span>()</code></th>
<td class="colLast">
<div class="block">Increments current evaluation set's false negatives count.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#incrementFalsePositives()">incrementFalsePositives</a></span>()</code></th>
<td class="colLast">
<div class="block">Increments current evaluation set's false positives count.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#incrementTrueNegatives()">incrementTrueNegatives</a></span>()</code></th>
<td class="colLast">
<div class="block">Increments current evaluation set's true negatives count.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#incrementTruePositives()">incrementTruePositives</a></span>()</code></th>
<td class="colLast">
<div class="block">Increments current evaluation set's true positives count.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#newEvaluationSet()">newEvaluationSet</a></span>()</code></th>
<td class="colLast">
<div class="block">Adds a mew BinaryEvaluationSet to this instance which is then set as the currentEvaluationSet.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#performanceReportAveraged()">performanceReportAveraged</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns a String containing a performance report that features:</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#recalculateConfusionMatricesForNewThreshold(double)">recalculateConfusionMatricesForNewThreshold</a></span>&#8203;(double&nbsp;newThreshold)</code></th>
<td class="colLast">
<div class="block">Sets the classification thresholds for all contained BinaryEvaluationSets to a new value and recalculates their respective confusion matrices
 based on the new threshold; this requires the EvaluationSets to have scoring and actual-class information!</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>BinaryClassificationEvaluator</h4>
<pre>public&nbsp;BinaryClassificationEvaluator()</pre>
<div class="block">This standard-constructor will set the classification-threshold to a default of 0.5 and
 will create and set a first <a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation"><code>BinaryEvaluationSet</code></a>.</div>
</li>
</ul>
<a id="&lt;init&gt;(double)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BinaryClassificationEvaluator</h4>
<pre>public&nbsp;BinaryClassificationEvaluator&#8203;(double&nbsp;classificationThreshold)</pre>
<div class="block">Creates a BinaryClassificationEvaluator taking a classification-threshold to be
 used when labeling. Remark that this already creates a first evaluation set,
 so if you want to just evaluate one test-run (i.e. not doing cross-validation),
 you are already set. If you want to do crossvalidation you have to call
 <a href="#newEvaluationSet()"><code>newEvaluationSet()</code></a> after each individual run
 to receive correctly averaged performance reports.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>classificationThreshold</code> - the classification threshold used in labeling.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="newEvaluationSet()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>newEvaluationSet</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;newEvaluationSet()</pre>
<div class="block">Adds a mew BinaryEvaluationSet to this instance which is then set as the currentEvaluationSet.</div>
</li>
</ul>
<a id="addWeightedGainConfig(double,double,double,double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addWeightedGainConfig</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;addWeightedGainConfig&#8203;(double&nbsp;tprWeight,
                                  double&nbsp;tnrWeight,
                                  double&nbsp;probPos,
                                  double&nbsp;probNeg)</pre>
<div class="block">Adds a new WeightedGainWeightingInfo to this instance. Calling one of the performanceReport methods will include
 estimated WeightedGain values for each configuration that is present in this class.
 The new weighted-gain-config will be added to each EvaluationSet currently associated with this instance.

 Adding additional configs is especially useful to estimate a weighted gain on populations that have a different distribution than
 validation-sets.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tprWeight</code> - weight that will be given to TPR</dd>
<dd><code>tnrWeight</code> - weight that will be given to TNR</dd>
<dd><code>probPos</code> - estimation of the probability to encounter a positive example</dd>
<dd><code>probNeg</code> - estimation of the probability to encounter a negative example</dd>
</dl>
</li>
</ul>
<a id="evaluate(double,double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>evaluate</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;evaluate&#8203;(double&nbsp;actualClass,
                        double&nbsp;score)</pre>
<div class="block">Evaluates a given score and actual class; that means that the score is compared with the classification threshold of the current EvaluationSet
 and according to the given actual class TN/TP/FN/FP values are incremented as necessary.
 All calls of this method are delegated to the currentEvaluationSet. It is highly recommended to use this method whenever
 a ML algorithm is used that is able to produce scores as it will save scoring and actual class data to the evaluation set to enable advanced
 features like fast recalculation of measures for shifting thresholds! It is basically an intelligent wrapper around the basic incrementXY-methods.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>actualClass</code> - actual class of the example from which the score was derived (1 for positive examples, else negative)</dd>
<dd><code>score</code> - the score that was calculated by a ML-model for the example in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if classification was correct, false if not (for convenience)</dd>
</dl>
</li>
</ul>
<a id="recalculateConfusionMatricesForNewThreshold(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>recalculateConfusionMatricesForNewThreshold</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;recalculateConfusionMatricesForNewThreshold&#8203;(double&nbsp;newThreshold)</pre>
<div class="block">Sets the classification thresholds for all contained BinaryEvaluationSets to a new value and recalculates their respective confusion matrices
 based on the new threshold; this requires the EvaluationSets to have scoring and actual-class information!
 This function can be used to quickly calculate differing measures for shifting thresholds without having to repeat the learning process to
 gather the scores.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>newThreshold</code> - the new threshold</dd>
</dl>
</li>
</ul>
<a id="incrementTruePositives()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incrementTruePositives</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;incrementTruePositives()</pre>
<div class="block">Increments current evaluation set's true positives count.</div>
</li>
</ul>
<a id="incrementFalsePositives()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incrementFalsePositives</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;incrementFalsePositives()</pre>
<div class="block">Increments current evaluation set's false positives count.</div>
</li>
</ul>
<a id="incrementTrueNegatives()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incrementTrueNegatives</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;incrementTrueNegatives()</pre>
<div class="block">Increments current evaluation set's true negatives count.</div>
</li>
</ul>
<a id="incrementFalseNegatives()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incrementFalseNegatives</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;incrementFalseNegatives()</pre>
<div class="block">Increments current evaluation set's false negatives count.</div>
</li>
</ul>
<a id="getEvaluationSets()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEvaluationSets</h4>
<pre class="methodSignature">public&nbsp;java.util.List&lt;<a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation">BinaryEvaluationSet</a>&gt;&nbsp;getEvaluationSets()</pre>
<div class="block">Returns a list of this instances evaluation-sets.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list of this instances evaluation-sets</dd>
</dl>
</li>
</ul>
<a id="getCurrentEvaluationSet()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCurrentEvaluationSet</h4>
<pre class="methodSignature">public&nbsp;<a href="BinaryEvaluationSet.html" title="class in bous.philipp.dblp.datatools.evaluation">BinaryEvaluationSet</a>&nbsp;getCurrentEvaluationSet()</pre>
<div class="block">Returns the current evaluation set.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current evaluation set</dd>
</dl>
</li>
</ul>
<a id="performanceReportAveraged()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>performanceReportAveraged</h4>
<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;performanceReportAveraged()</pre>
<div class="block">Returns a String containing a performance report that features:
 <p>
 * tpr
 * tnr
 * precision
 * negative predictive value
 * accuracy
 * F1-score
 <p>
 averaged over all EvaluationSets that are present in this BinaryClassificationEvaluator-object.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the performance-report string</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
